unit RegistryU;

interface

uses Generics.Collections, System.Classes, TypesU;

type

  IPlugins = interface
    ['{D6E4416E-A773-4F51-883C-70A2EC8FB073}']
    procedure AddTransform(ATransform: TBaseTransform);
    function Transforms: TObjectList<TBaseTransform>;
  end;

function MarshalPlugins: IPlugins;

implementation

uses Web, JS;

type
  /// <summary>Plugin Factory Class  </summary>
  TMarshalPluginFactory = class
  strict private
    class var FPlugins: IPlugins;
    class constructor Create;
  public
    // function InitializePlugins: IMarshalPlugins;
    class property MarshalPlugins: IPlugins read FPlugins;
  end;

  /// <summary>Plugin Registry Class    </summary>
  TMarshalPlugins = class(TInterfacedObject, IPlugins)
  strict private
    FTransforms: TObjectList<TBaseTransform>;
  public
    constructor Create;
    destructor Destroy; override;
    procedure AddTransform(ATransform: TBaseTransform);
    function Transforms: TObjectList<TBaseTransform>;
  end;

function MarshalPlugins: IPlugins;
var
  s: string;
begin
  result := TMarshalPluginFactory.MarshalPlugins;
  s := '23';
end;

{ TMarshalPluginFactory }

class constructor TMarshalPluginFactory.Create;
begin
  FPlugins := TMarshalPlugins.Create;
  console.log('Factory created');
end;

{ TMarshalPlugins }

procedure TMarshalPlugins.AddTransform(ATransform: TBaseTransform);
begin
  FTransforms.Add(ATransform);
  console.log('added transform ' + ATransform.ClassName);
end;

constructor TMarshalPlugins.Create;
begin
  FTransforms := TObjectList<TBaseTransform>.Create(true);
end;

destructor TMarshalPlugins.Destroy;
begin
  FTransforms.Free;
  inherited;
end;

function TMarshalPlugins.Transforms: TObjectList<TBaseTransform>;
begin
  result := FTransforms;
end;

end.
